//+-----------------------------------------------------------------------------------------+
//|  cm_Line_Revers,        Revers_ |
//|           Revers_1                  |
//|    Revers_1, Revers_2, Revers_3...                                     |
//|                                   |
//|                                                                                         |
//|                                  Copyright  2012, Vladimir Khlystov, cmillion@narod.ru |
//+-----------------------------------------------------------------------------------------+
#property copyright "Copyright  2012, Vladimir Khlystov"
#property link      "cmillion@narod.ru"
//--------------------------------------------------------------------
int slippage=3;
int init()
{
   if (Digits==3 || Digits==5) slippage=30;
   Comment("C cm_Line_Revers ",TimeToStr(TimeCurrent(),TIME_DATE|TIME_MINUTES));
}
//--------------------------------------------------------------------
int start()
{
   int OT,b,s;
   double OrdersB[100][3],OrdersS[100][3];
   //---
   for (int j = OrdersTotal()-1; j >= 0; j--)
   {
      if (OrderSelect(j, SELECT_BY_POS))
      {
         if (OrderSymbol() == Symbol())
         {
            OT = OrderType();
            if (OT==OP_BUY) 
            {
               OrdersB[b][0]=OrderOpenPrice();
               OrdersB[b][1]=OrderLots();
               OrdersB[b][2]=OrderTicket();
               b++;
            }
            if (OT==OP_SELL) 
            {
               OrdersS[s][0]=OrderOpenPrice();
               OrdersS[s][1]=OrderLots();
               OrdersS[s][2]=OrderTicket();
               s++;
            }
         }
      }
   }
   if (b+s==0) Comment(" ");
   //---
   double Line[100];
   int l;
   string txt,Name;
   for(int i=ObjectsTotal()-1; i>=0; i--) 
   {
      Name=ObjectName(i);
      OT = ObjectType(Name);
      if (OT==OBJ_HLINE || OT==OBJ_TREND)
      {
         if (StringSubstr(Name,0,6)=="Revers") 
         {
            if (OT==OBJ_TREND) Line[l] = NormalizeDouble(ObjectGetValueByShift(Name,0),Digits);
            if (OT==OBJ_HLINE) Line[l] = NormalizeDouble(ObjectGet(Name,OBJPROP_PRICE1),Digits);
            txt = StringConcatenate(txt,"\n",DoubleToStr(Line[l],Digits));
            l++;
         }
      }
   }
   if (l==0) Comment("    Revers_");
   else Comment("  :",txt);
   //---
   int Ticket;
   for(i=0; i<l; i++) 
   {
      if (Line[i]<=Bid) // Buy  
      {
         for(j=0; j<b; j++) 
         {
            if (OrdersB[j][0]<Line[i]) //   
            {
               Ticket = OrdersB[j][2];
               if (OrderClose(Ticket,OrdersB[j][1],NormalizeDouble(Bid,Digits),slippage,Blue))
                  if (OrderSend(Symbol(),OP_SELL,OrdersB[j][1],NormalizeDouble(Bid,Digits),slippage,0,0,"cm_Line_Revers",0,0,Red)!=-1)
                     Comment("Revers Orders BUY -> SELL ",DoubleToStr(Line[i],Digits),"  ",TimeToStr(TimeCurrent(),TIME_DATE|TIME_SECONDS));
            }
         }
      }
      if (Line[i]>=Ask) // Ask  
      {
         for(j=0; j<s; j++) 
         {
            if (OrdersS[j][0]>Line[i]) //   
            {
               Ticket = OrdersS[j][2];
               if (OrderClose(Ticket,OrdersS[j][1],NormalizeDouble(Ask,Digits),slippage,Red))
                  if (OrderSend(Symbol(),OP_BUY,OrdersS[j][1],NormalizeDouble(Ask,Digits),slippage,0,0,"cm_Line_Revers",0,0,Blue)!=-1)
                     Comment("Revers Orders SELL -> BUY ",DoubleToStr(Line[i],Digits),"  ",TimeToStr(TimeCurrent(),TIME_DATE|TIME_SECONDS));
            }
         }
      }
   }
   return(0);
}
//--------------------------------------------------------------------

